How can I “try to do something and then detect if it fails” in bash?

前端 未结 3 1836
后悔当初
后悔当初 2020-12-19 14:21

In an answer to a previous question:

How can I use 'do I have root access?' as a conditional in bash?

The suggestion to \'try to do something and de

相关标签:
3条回答
  • 2020-12-19 14:58

    Bash depends on exit status so there isn't any try/catch equivalent. But it's still powerful to fit your needs.

    For simple cases, you can use

    [[ your_test_expression ]] && commands
    

    This is equivalent to

    if [[ your_test_expression ]]; then
        commands
    fi
    

    If uses the "exit status" of [[ ... ]] so actually you can use any command after if. Just make sure your control logic depends on the exit status of the command.

    For complicated cases, you still need if or case statements to express your logic.

    0 讨论(0)
  • 2020-12-19 15:06
    if sudo chmod a-x /etc/shadow 2>/dev/null
    then : Yes - I have root permissions
    else : No - I do not have root permissions or /etc/shadow does not exist or ...
    fi
    

    This chooses an operation that does no damage if it succeeds (the shadow password file is not supposed to be executable; you could do something like chmod o-w / - remove public write permission from the root directory if you prefer), and check that it worked by looking at the exit status of the command. This throws away the error message - you have to decide whether that matters.

    The 'sudo' is there to raise the privileges; if you think the user should already be 'root', then omit the 'sudo'.

    0 讨论(0)
  • 2020-12-19 15:06

    unless the script you are calling has an exit condition, there isn't much you can do. However look up "set" in the bash man page.

    set -e
    

    will cause a script to exit if a simple command in it fails. You can add it to the top of script.sh in your example to cause it to exit if it fails.

    also look at trap. I believe

    trap 'exit 2' ERR
    

    is similar

    0 讨论(0)
提交回复
热议问题